Subject: Re: bug#22097: Ispell: lazy highlighting doesn't work properly.

From: Eli Zaretskii <[email-masked]>
Date: Sat, 05 Dec 2015 16:20:38 +0200

> Date: Sat, 5 Dec 2015 14:06:09 +0000
> Cc: [email-masked]
> From: Alan Mackenzie <[email-masked]>
> 
> > This is a "feature".  Ispell skips regions determined by certain
> > regexps, see ispell-skip-region-alist.  In this case, the ASCII-art
> > diagram around the second occurrence of "xdisp" includes regions that
> > match some of the regexps (AFAICT, the '+' character followed and
> > preceded by '-' triggers that).  Lazy highlight doesn't want to try
> > matching in those skip-regions, and since it cannot support
> > non-contiguous regions, it simply limits itself to the beginning of
> > the first such region, which happens to be before the second "xdisp".
> 
> Ah.  I didn't know this.

Neither did I.  I just traced through the code, is all.

> However, the bug manifests itself a bit later on in plain text.
> 
> There's a paragraph starting at L199 about bidi.  After several more
> hits on the space bar, the first occurrence of "bidi" (L201) gets
> highlighted; the second occurrence (on the same line) gets lazily
> highlighted.  The third (L204) and fourth (L205) remain unhighlighted.
> 
> Hit the spacebar another time.  All four occurrences are now
> highlighted.
> 
> As far as I can see, there's nothing remotely ASCII-arty in that
> paragraph.  Unless the "---" sequences are somehow being interpreted as
> ASCII-art.

ispell-skip-region-alist is a complex regexp, something there must've
(mis)fired.